<?php
################################################################################
# @Name : /core/ldap.php
# @Desc : page to synchronize users from LDAP to GestSup
# @call : /admin/user.php
# @Author : Flox
# @Create : 15/10/2012
# @Update : 24/11/2015
# @Version : 3.1.0
################################################################################

//initialize variables
if(!isset($_POST['test_ldap'])) $_POST['test_ldap'] = '';
if(!isset($dcgen)) $dcgen = '';

//LDAP connection parameters
$user=$rparameters['ldap_user']; 
$password=$rparameters['ldap_password']; 
$hostname=$rparameters['ldap_server'];
$domain=$rparameters['ldap_domain'];

//Generate DC Chain from domain parameter
$dcpart=explode(".",$domain);
$i=0;
while($i<count($dcpart)) {
	$dcgen="$dcgen,dc=$dcpart[$i]";
	$i++;
}
	
//LDAP URL for users emplacement
$ldap_url="ou=ordinateur$dcgen";

//LDAP connect
$ldap = ldap_connect($hostname,$rparameters['ldap_port']) or die("Impossible de se connecter au serveur LDAP.");
ldap_set_option($ldap, LDAP_OPT_NETWORK_TIMEOUT, 1);
if ($rparameters['ldap_type']==1) {ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);}
//check LDAP type for bind
if ($rparameters['ldap_type']==0) $ldapbind = ldap_bind($ldap, "$user@$domain", $password); else $ldapbind = ldap_bind($ldap, "cn=$user$dcgen", $password);	
//check ldap authentication
if ($ldapbind) {$ldap_connection="<i title=\"Connecteur opérationnel\" class=\"icon-ok-sign icon-large green\"></i> Connecteur opérationnel.";} else {$ldap_connection="<i title=\"Le connecteur ne fonctionne pas vérifier vos paramètres\" class=\"icon-remove-sign icon-large red\"></i> Le connecteur ne fonctionne pas vérifier vos paramètres";}

echo $ldap_connection;

	// ry * -filter "&(objectClass=Computer)(sAMAccountName=<ComputerName>$)" -attr *
	
	
$filter="(&(objectClass=computer)(cn=*))";
$query = @ldap_search($ldap, $ldap_url, $filter);
//put all data to $data
$data = @ldap_get_entries($ldap, $query);
//count LDAP number of users
$cnt_ldap = @ldap_count_entries($ldap, $query);

echo "<br />nombre de pc $cnt_ldap<br />";
for ($i=0; $i < $cnt_ldap; $i++) 
{
	$ldap_netbios=$data[$i]['cn'][0];
	$ldap_lastlogon=date('Y-m',$data[$i]['lastlogon'][0]);
	$ldap_os=$data[$i]['operatingsystem'][0];
	$ldap_guid=$data[$i]['objectguid'][0];
	
	echo "netbios: $ldap_netbios<br />";
	echo "lastlogon: $ldap_lastlogon<br />";
	echo "os: $ldap_os<br />";
	echo "<br />";
}
?>